//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    CCIPeriod       = 50;
extern int    CCIPrice        = PRICE_TYPICAL;
extern double levelOs         = -100;
extern double levelOb         = 100;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsPush      = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double sigUp[];
double sigDn[];
double cci[];
double prices[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,sigUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,sigDn); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,cci);
      SetIndexBuffer(3,prices);
      SetIndexBuffer(4,trend1);
      SetIndexBuffer(5,trend2);

   IndicatorShortName(" CCI ("+CCIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i);
      double avg = 0; for(k=0; k<CCIPeriod; k++) avg +=         prices[i+k];      avg /= CCIPeriod;
      double dev = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIPeriod;
          if (dev!=0)
                cci[i] = (prices[i]-avg)/(0.015*dev);
          else  cci[i] = 0;
         
          //
          //
          //
          //
          //
         
          trend1[i] = 0;
             if (cci[i]>levelOb) trend1[i] = 1;
             if (cci[i]<levelOs) trend1[i] =-1;
             
             //
             //
             //
             //
             //
             
             trend2[i] = trend2[i+1];
             sigUp[i] = EMPTY_VALUE;
             sigDn[i] = EMPTY_VALUE;
               if (trend1[i] == 0 && trend1[i+1] ==-1) trend2[i] = 1;
               if (trend1[i] == 0 && trend1[i+1] == 1) trend2[i] =-1;
               if (trend2[i] == 1) sigUp[i] = 1;
               if (trend2[i] ==-1) sigDn[i] = 1;
       }
       
       //
       //
       //
       //
       //
          
       if (alertsOn)
       {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(whichBar,"Buy");
            if (trend2[whichBar] == -1) doAlert(whichBar,"Sell");
         }           
   }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," cci "),message);
             if (alertsPush)    SendNotification(StringConcatenate(Symbol(), Period() ," cci " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
   }
}
   
   